dnl AC_MYSQLCLIENT 
dnl Detect mysql client library 
dnl
AC_DEFUN([AC_MYSQL_CLIENT], [
  mysqlclient_save_CPPFLAGS="$CPPFLAGS"
  mysqlclient_save_LDFLAGS="$LDFLAGS"
  AC_LANG_PUSH(C)
  dnl 
  dnl provide a with option 
  dnl 
  AC_CHECK_PROG(have_prog_mysql_config, [mysql_config], [yes], [no])
  if test "$have_prog_mysql_config" = "yes" ; 
  then 
    HAVE_MYSQL_CLIENT=yes
    MYSQL_CLIENT_CFLAGS=`mysql_config --cflags`
    MYSQL_CLIENT_LIBS=`mysql_config --libs`
  else
    HAVE_MYSQLCLIENT=no
  fi 
  AC_LANG_POP(C)
  CPPFLAGS="$mysqlclient_save_CPPFLAGS"
  LDFLAGS="$mysqlclient_save_LDFLAGS"
])
dnl AC_MYSQLPP 
dnl detect the availability of Mysql++ C++ wrapper arround mysql 
dnl 
AC_DEFUN([AC_MYSQLPP], [
  dnl save environment 
  mysqlpp_save_CPPFLAGS="$CPPFLAGS"
  mysqlpp_save_LDFLAGS="$LDFLAGS"
  AC_LANG_PUSH(C++)
  mysqlpp_search_path="/usr/local /usr"
  AC_ARG_WITH([mysqlpp], 
              [  --with-mysqlpp=path   the path to the mysqlpp installation], 
              [if test "$withval" != no ; 
               then
                  mysqlpp_search_path="$withval $mysqlpp_search_path" 
               fi 
              ], [])
  AC_MYSQLCLIENT
  if test "$HAVE_MYSQLCLIENT" = "yes"  
  then 
    for dir in $mysqlpp_search_path  
    do
      if test "$HAVE_MYSQLPP" != "yes"
      then 
        AC_MSG_CHECKING([for mysql++ in $dir])
        if test -f "$dir/include/mysql++/mysql++.h" 
        then
          AC_MSG_RESULT([found])
          dnl Do a real detection there 
          HAVE_MYSQLPP=yes
          AC_SUBST(HAVE_MYSQLPP)
          MYSQLPP_CFLAGS="-I$dir/include/mysql++ $MYSQLCLIENT_CFLAGS"
          AC_SUBST(MYSQLPP_CFLAGS)
          MYSQLPP_LIBS="-L$dir/lib/ -lmysqlpp $MYSQLCLIENT_LDFLAGS"
          AC_SUBST(MYSQLPP_LIBS)
        else 
          AC_MSG_RESULT([not found])
        fi
      fi 
    done 
  fi
  if test "$HAVE_MYSQLPP" != "yes" 
  then 
    HAVE_MYSQLPP=no
    AC_SUBST(HAVE_MYSQLPP)
  fi
  dnl restore environment                 
  AC_LANG_POP(C++)
  CPPFLAGS="$mysqlpp_save_CPPFLAGS"
  LDFALGS="$mysqlpp_save_LDFLAGS"
])
