dnl Detect OmniRPC environment 
AC_DEFUN([AC_OMNIRPC], [
dnl save environment 
omnirpc_sav_CPPFLAGS="$CPPFLAGS"
omnirpc_sav_CFLAGS="$CFLAGS"
omnirpc_sav_LDFLAGS="$LDFALGS"
omnirpc_sav_LIBS="$LIBS"
AC_LANG_PUSH(C)

ACX_PTHREAD([
  omnrpc_have_pthread=yes
], [ 
  omnrpc_have_pthread=no
])
if test "$omnrpc_have_pthread" = "yes"
then 
  dnl detect binaries application for omnirpc 
  AC_CHECK_PROG(have_prog_omrpc_agent,    [omrpc-agent],    [yes], [no])
  AC_CHECK_PROG(have_prog_omrpc_cc,       [omrpc-cc],       [yes], [no])  
  AC_CHECK_PROG(have_prog_omrpc_fc,       [omrpc-fc],       [yes], [no])
  AC_CHECK_PROG(have_prog_omrpc_gen,      [omrpc-gen],      [yes], [no])
  AC_CHECK_PROG(have_prog_omrpc_monitor,  [omrpc-monitor],  [yes], [no])
  AC_CHECK_PROG(have_prog_omrpc_register, [omrpc-register], [yes], [no])
  AC_CHECK_PROG(have_prog_omrpc_tlogview, [omrpc-tlogview], [yes], [no])
  if test "$have_prog_omrpc_agent"  = "yes" 
  then
    HAVE_OMRPC_AGENT=yes
    OMRPC_AGENT=`which omrpc-agent`
  fi
  if test "$have_prog_omrpc_cc" = "yes"
  then 
    HAVE_OMRPC_CC=yes
    OMRPC_CC=`which omrpc-cc`
  fi
  if test "$have_prog_omrpc_fc" = "yes"
  then 
    HAVE_OMRPC_FC=yes
    OMRPC_FC=`which omrpc-fc`
    
  fi
  if test "$have_prog_omrpc_gen" = "yes"
  then 
    HAVE_OMRPC_GEN=yes
    OMRPC_GEN=`which omrpc-gen`
  fi 
  if test "$have_prog_omrpc_monitor" = "yes"
  then
    HAVE_OMRPC_MONITOR=yes
    OMRPC_MONITOR=`which omrpc-monitor`
  fi 
  if test "$have_prog_omrpc_register" = "yes"
  then
    HAVE_OMRPC_REGISTER=yes
    OMRPC_REGISTER=`which omrpc-register`
  fi
  if test "$have_prog_omrpc_tlogview" = "yes"
  then
    HAVE_OMRPC_TLOGVIEW=yes
    OMRPC_TLOGVIEW=`which omrpc-tlogview`
  fi 
  dnl detect omnirpc prefix 
  if test "$HAVE_OMRPC_GEN" = "yes" 
  then 
    omnrpc_bindir=`dirname $OMRPC_GEN`
    omnrpc_prefix=`dirname $omnrpc_bindir`
    OMNRPC_DIR=$omnrpc_prefix
    dnl detect header
    OMNRPC_CFLAGS=""
    if test -f "$omnrpc_prefix/include/OmniRpc.h" 
    then 
      OMNRPC_CFLAGS="-I$omnrpc_prefix/include $PTHREAD_CFLAGS"
      have_omnrpc_omnirpc_h=yes
    else 
      AC_CHECK_HEADERS([OmniRpc.h],[have_omnrpc_omnirpc_h=yes],[have_omnrpc_omnirpc_h=no]) 
    fi 
    dnl detect lib 
    if test -f "$omnrpc_prefix/lib/libomrpc_io.a" -a -f "$omnrpc_prefix/lib/libomrpc_client.a" -a -f "$omnrpc_prefix/lib/libomrpc_stub.a"
    then 
      have_omrpc_lib=yes
      OMNRPC_CLIENT_LIBS="-L$omnrpc_prefix/lib -lomrpc_client -lomrpc_io $PTHREAD_LIBS"
      OMNRPC_STUB_LIBS="-L$omnrpc_prefix/lib -lomrpc_stub -lomrpc_io $PTHREAD_LIBS"
    else
      have_omrpc_lib=no 
    fi
    if test "$have_omnrpc_omnirpc_h" = "yes" -a "$have_omrpc_lib" = "yes" 
    then
      HAVE_OMNIRPC=yes
    else 
      HAVE_OMNIRPC=no
    fi
  fi
fi
AC_LANG_POP(C)
CPPFLAGS="$omnirpc_sav_CPPFLAGS"
CFLAGS="$omnirpc_sav_CFLAGS"
LDFLAGS="$omnirpc_sav_LDFLAGS"
LIBS="$omnirpc_sav_LIBS"
])
