dnl ---------------------------------------------------------------------
dnl Check for Expat availability 
dnl UTIL_CHECK_EXPAT([prefix], [action-if-found], [action-if-not-found])
dnl ---------------------------------------------------------------------
AC_DEFUN([YML_CHECK_EXPAT], [
    AC_ARG_WITH([expat-incdir], AC_HELP_STRING([--with-expat-incdir=DIR], [Optionally specifies location of the expat-c++ includes]),
        [yml_expat_incdir=$withval],[yml_expat_incdir=[.]])
    AC_ARG_WITH([expat-libdir], AC_HELP_STRING([--with-expat-libdir=DIR], [Optionally specifies location of the expat-c++ library]),
        [yml_expat_libdir=$withval],[yml_expat_libdir=[.]])
    yml_lib_paths="$yml_expat_libdir"
    yml_inc_paths="$yml_expat_incdir /usr/local/include/expat /usr/include/expat /usr/local/include /usr/include"

    $1_CFLAGS=
    $1_LIBS=

    yml_saved_CFLAGS="$CPPFLAGS"
    yml_saved_LIBS="$LIBS"

    for yml_path in $yml_inc_paths; do
        ifelse($yml_path, [.], CPPFLAGS="$yml_saved_CFLAGS", CPPFLAGS="-I$yml_path $yml_saved_CFLAGS")
        AC_PREPROC_IFELSE(
            [#include <expat.h>],
            [yml_expat_h_found=yes; yml_expat_flags="$yml_path"; break],
            [yml_expat_h_found=no])
    done

    for yml_path in $yml_lib_paths; do
        ifelse($yml_path, [.], LIBS="$yml_saved_LIBS", LIBS="-L$yml_path $yml_saved_LIBS")
        AC_CHECK_LIB([expat], [XML_ParserCreate],
            [yml_expat_l_found=yes; yml_expat_libs="$yml_path"; break],
            [yml_expat_l_found=no; unset ac_cv_lib_expat-c_main])
    done

    CPPFLAGS="$yml_saved_CFLAGS"
    LIBS="$yml_saved_LIBS"

    if test x$yml_expat_h_found = xyes && test x$yml_expat_l_found = xyes; then
        if test x$yml_expat_flags != x.; then
            $1_CFLAGS="-I$yml_expat_flags"
        fi
        if test x$yml_expat_libs = x.; then
            $1_LIBS="-lexpat"
        else
            $1_LIBS="-L$yml_expat_libs -lexpat"
        fi

        ifelse([$2], [], :, [$2])
    else
        ifelse([$3], [], :, [$3])
    fi
])
dnl ---------------------------------------------------------------------

