/* -*- mode: c; c-file-style: "engine"; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/****************************************************************************
 * Copyright Olivier Delannoy, Laurent Choy 2005
 *
 * Olivier Delannoy   
 *   Olivier.Delannoy@gmail.com
 *   PRiSM Laboratory 
 *   Verailles University 
 *   45 avenue des Etats Unis 
 *   78035 Versailles Cedex FRANCE 
 *
 * Laurent Choy 
 *   Choy.Laurent@gmail.com
 *   INRIA Futurs
 *   Parc Club Orsay Universit                      
 *   ZAC des vignes                      
 *   2-4, rue Jacques Monod                      
 *   91893 Orsay Cedex France
 *
 *
 *
 * This software is a computer program whose purpose is to [describe
 * functionalities and technical features of your software].
 * 
 * This software is governed by the CeCILL  license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 ****************************************************************************/
#include <Yml/Worker/worker.h>
#include <Yml/Worker/drclient.h> 
#include <stdio.h>
#define DESCRIPTION "worker_job.txt" 

int main(int argc, char** argv)
{
    char* host;
    unsigned short port;
    char* path;
    char* data;
    unsigned int dataSize;  
    drclient_t client;
    int status;
    if (argc != 4)
    {
        printf("Wrong number of parameters\n");
        return -1;
    }
    port = strtoul(argv[2], &host, 0);
    if (host == argv[2] && port == 0)
    {
        printf("Invalid port number\n");
        return -1;
    }    
    host = argv[1];
    path = argv[3];
    printf("Retrieve work description: dr://%s:%d%s\n", host, port, path);
    status = drclient_connect(&client, host, port);
    if (status != 0)
    {
        printf("Unable to contact data repository\n");
        return status;
    }
    status = drclient_get_data(client, path, &data, &dataSize);
    if (status != 0)
    {
        printf("Unable to download data repository\n");
        drclient_disconnect(client);
        return status;
    }
    printf("Start the execution of the worker\n");
    status =  worker(data, dataSize, client);
    printf("End of the execution of the worker (%d)\n", status);
    if (dataSize)
		free(data);
    
    return status;
}
