/* -*- mode: c++; c-file-style: "engine"; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/****************************************************************************
 * Copyright Olivier Delannoy, Laurent Choy 2005
 *
 * Olivier Delannoy   
 *   Olivier.Delannoy@gmail.com
 *   PRiSM Laboratory 
 *   Verailles University 
 *   45 avenue des Etats Unis 
 *   78035 Versailles Cedex FRANCE 
 *
 * Laurent Choy 
 *   Choy.Laurent@gmail.com
 *   INRIA Futurs
 *   Parc Club Orsay Universit                      
 *   ZAC des vignes                      
 *   2-4, rue Jacques Monod                      
 *   91893 Orsay Cedex France
 *
 *
 *
 * This software is a computer program whose purpose is to [describe
 * functionalities and technical features of your software].
 * 
 * This software is governed by the CeCILL  license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 ****************************************************************************/
/**
 * @file
 * @brief Class XMPBinaryGenerator declaration
 */
#ifndef XMPBINARYGENERATOR_HH
#define XMPBINARYGENERATOR_HH 1
#include "BinaryGenerator.hh"

#define MPI_CC             "/usr/bin/mpicc"
#define XMP_DIR            "/home/mhugues/XMP"
#define XMP_CC             "/home/mhugues/XMP/bin/xmpcc"
#define XMP_LIB            XMP_DIR"/lib/libxmp.a"
#define OMRPC_DIR          "/home/mhugues/OMNIRPC"
#define OMRPC_GEN_XMP      "/home/mhugues/OMNIRPC/bin/omrpc-gen-xmp"
#define OMRPC_INCLUDE      OMRPC_DIR"/include"
#define OMRPC_LIB_STUB     OMRPC_DIR"/lib/libomrpc_stub.a"
#define OMRPC_LIB_IO       OMRPC_DIR"/lib/libomrpc_io.a"
#define YML_DIR            "/mnt/2.0.0-Fork"
#define YML_WORKER_INCLUDE YML_DIR"/src"
#define YML_WORKER_LIB     YML_DIR"/src/Yml/Worker/libymlworker.a"
#define YML_CONFIG_INCLUDE YML_DIR


namespace DefaultExecutionCatalog 
{
class XMPBinaryGenerator : public BinaryGenerator
{
public:
    explicit XMPBinaryGenerator(const Yml::Core::string& dataDir);
    
    ~XMPBinaryGenerator() 
    {
    }
    
    bool generate(const Yml::Core::ComponentImpl& impl, const Yml::Core::ParameterList& interface, const Yml::Core::string& dest);
private:
    bool createSourceCode(const Yml::Core::ComponentImpl& impl, const Yml::Core::ParameterList& interface, const Yml::Core::string& dest);
    bool createBinary(const Yml::Core::string& libraries, const Yml::Core::string& dest, const Yml::Core::string& src);
    bool createOmrpcIdl(const Yml::Core::ComponentImpl& impl, const Yml::Core::ParameterList& interface, const Yml::Core::string& dest);
    bool createRex(const Yml::Core::string& libraries, const Yml::Core::string& dest, const Yml::Core::string& src);
 
    
};

    
}
#endif
