/* -*- mode: c++; c-file-style: "engine"; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/**
 * @file
 * @brief Integer parameter wrapper for XMP
 *
 *
 *
 * 2012-01-12
 *
 */
#ifndef INTEGER_TYPE_HH
#define INTEGER_TYPE_HH 1

#include <stdint.h>
#include <stdbool.h>
#include <mpi.h>

typedef int32_t integer;


static bool integer_import(integer* param, char* filename)
{
	int ack;
	MPI_File   fh;
	MPI_Status status;

	ack = MPI_File_open(MPI_COMM_WORLD,filename,MPI_MODE_RDONLY,MPI_INFO_NULL,&fh);

	if (ack != MPI_ERR_NO_SUCH_FILE)
	{
		MPI_File_read_all(fh,param,1,MPI_INT,&status);
		MPI_File_close(&fh);
		return true;
	}

	MPI_File_close(&fh);
	return false;
}

static bool integer_export(integer* param, char* filename)
{
	int ack, rank;
	MPI_File   fh;
	MPI_Status status;

	MPI_Comm_rank(MPI_COMM_WORLD,&rank);

	ack = MPI_File_open(MPI_COMM_WORLD,filename,MPI_MODE_WRONLY| MPI_MODE_CREATE,MPI_INFO_NULL,&fh);

	if (ack != MPI_ERR_NO_SUCH_FILE)
	{
		MPI_File_write_all(fh,param,1,MPI_INT,&status);
		MPI_File_close(&fh);
		if(rank==0)
		{
			FILE *fp;
			fp=fopen("output.txt","a");
			fprintf(fp,"%s\n",filename);
			fclose(fp);
		}

		return true;
	}

	MPI_File_close(&fh);


	return false;
}

#endif
