/* -*- mode: c++; c-file-style: "engine"; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/**
 * @file
 * @brief Integer parameter wrapper for XMP
 *
 *
 *
 * 2012-01-12
 *
 */
#ifndef REAL_XMP_TYPE_HH
#define REAL_XMP_TYPE_HH 1

#include <stdint.h>
#include <stdbool.h>
#include <mpi.h>

typedef double real;



static bool real_import(real* param, char* filename)
{
	int ack;
	MPI_File   fh;
	MPI_Status status;

	ack = MPI_File_open(MPI_COMM_WORLD,filename,MPI_MODE_RDONLY,MPI_INFO_NULL,&fh);

	if (ack != MPI_ERR_NO_SUCH_FILE)
	{
		MPI_File_read_all(fh,param,1,MPI_DOUBLE,&status);
		MPI_File_close(&fh);
		return true;
	}

	MPI_File_close(&fh);
	return false;
}

static bool real_export(real* param, char* filename)
{
	int ack;
	MPI_File   fh;
	MPI_Status status;

	ack = MPI_File_open(MPI_COMM_WORLD,filename,MPI_MODE_WRONLY| MPI_MODE_CREATE,MPI_INFO_NULL,&fh);

	if (ack != MPI_ERR_NO_SUCH_FILE)
	{
		MPI_File_write_all(fh,param,1,MPI_DOUBLE,&status);
		MPI_File_close(&fh);
		return true;
	}

	MPI_File_close(&fh);
	return false;
}

#endif
