/* -*- mode: c++; c-file-style: "engine"; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/****************************************************************************
 * Copyright Olivier Delannoy, Laurent Choy 2005
 *
 * Olivier Delannoy   
 *   Olivier.Delannoy@gmail.com
 *   PRiSM Laboratory 
 *   Verailles University 
 *   45 avenue des Etats Unis 
 *   78035 Versailles Cedex FRANCE 
 *
 * Laurent Choy 
 *   Choy.Laurent@gmail.com
 *   INRIA Futurs
 *   Parc Club Orsay Universit                      
 *   ZAC des vignes                      
 *   2-4, rue Jacques Monod                      
 *   91893 Orsay Cedex France
 *
 *
 *
 * This software is a computer program whose purpose is to [describe
 * functionalities and technical features of your software].
 * 
 * This software is governed by the CeCILL  license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 ****************************************************************************/

/**
 * @file
 * @brief Yml::Compiler  namespace global typename 
 *  
 * 2005-06-05
 * Olivier Delannoy
 */
#ifndef YML_COMPILER_NAMESPACE_HH
#define YML_COMPILER_NAMESPACE_HH 1
#include <Yml/Core/core.hh>
namespace Yml {
    /** 
     * @brief Application Compiler namespace 
     *
     * This namespace corresponds to the application compiler for the
     * YvetteML language.
     */ 
    namespace Compiler {
        /** Signed integer of 8 bits */ 
        typedef Yml::Core::int8 int8;    
        /** Unsigned integer of 16 bits */
        typedef Yml::Core::uint16 uint16;
        /** Signed integer of 16 bits */
        typedef Yml::Core::int16 int16;  
        /** Unsigned integer of 32 bits */
        typedef Yml::Core::uint32 uint32; 
        /** Signed integer of 32 bits */
        typedef Yml::Core::int32 int32;  
        /** Unsigned integer of 64 bits */ 
        typedef Yml::Core::uint64 uint64;
        /** Signed integer of 64 bits */ 
        typedef Yml::Core::int64 int64;  
        /** 32 bits Real number */
        typedef Yml::Core::real32 real32;
        /** 64 bits Real number */
        typedef Yml::Core::real64 real64;
        /** a byte 8 bits long data */
        typedef Yml::Core::byte byte;    
        /** a word 16 bits long data */ 
        typedef Yml::Core::word word;   
        /** a double word 32 bits long data */  
        typedef Yml::Core::dword dword; 
        /** a quad word 64 bits long data */
        typedef Yml::Core::qword qword;  
        /** a string of text */
        typedef Yml::Core::string string;
    }
}
#endif

