/*
// ***********************************************************************
// VFS library 
// Author: Olivier Delannoy
// Date: 15 Jul 2007
// ***********************************************************************
// Copyright (c) 2006 listed in Authors.txt file 
//
// Permission is hereby granted, free of charge, to any person 
// obtaining a copy of this software and associated documentation 
// files (the "Software"), to deal in the Software without restriction,
// including without limitation the rights to use, copy, modify, merge,
// publish, distribute, sublicense, and/or sell copies of the Software,
// and to permit persons to whom the Software is furnished to do so, 
// subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be 
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 
// BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
// ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// ***********************************************************************
 */
#include "vfs.h"
#include <stdio.h> 

#define BUFFER_SIZE 1024*1024
int vfs_file_copy(char* dest, char* source)
{
    char buffer[BUFFER_SIZE];
    FILE* fSrc = fopen(source, "rb");
    FILE* fDest = 0;
    if (! fSrc)
    {
        return -1;
    }
    fDest = fopen(dest, "wb");
    if (! fDest)
    {
        fclose(fSrc);
        return -1;
    }
    while(!feof(fSrc))
    {
        int status = fread(buffer, 1, BUFFER_SIZE, fSrc);
        if (status != -1)
        {
            int status2 = fwrite(buffer, 1, status, fDest);
            if (status2 == -1)
            {
                fclose(fDest);
                fclose(fSrc);
                remove(dest);
                return -1;
            }
        }
    }
    fclose(fDest);
    fclose(fSrc);
    return 0;    
}
/****************************************************************************/
