/*
// ***********************************************************************
// Digest library 
// Author: Olivier Delannoy
// Date: 15 Jul 2007
// ***********************************************************************
// Copyright (c) 2006 listed in Authors.txt file 
//
// Permission is hereby granted, free of charge, to any person 
// obtaining a copy of this software and associated documentation 
// files (the "Software"), to deal in the Software without restriction,
// including without limitation the rights to use, copy, modify, merge,
// publish, distribute, sublicense, and/or sell copies of the Software,
// and to permit persons to whom the Software is furnished to do so, 
// subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be 
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 
// BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN 
// ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
// CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// ***********************************************************************
*/
#include "vfs.h"
#include <stdio.h>
#include <stdlib.h> 
#include <string.h> 
int main()
{
  int status;
  status = vfs_mkdir("/tmp/truc/bidule", 0700);
  if (status != 0) {
    perror("vfs_mkdir");
    return EXIT_FAILURE;
  }
  printf("directory created successfully\n");
  status = vfs_file_copy("/tmp/truc/vfs_test.c", "vfs_test.c");
  if (status != 0) {
      perror("vfs_file_copy");
      return EXIT_FAILURE;
  }
  printf("file copy successfull\n");
  status = vfs_rmdir("/tmp/truc");
  if (status != 0) {
    perror("vfs_rmdir");
    return EXIT_FAILURE;
  }
  printf("directory destroyed successfully\n");
 

  
  return EXIT_SUCCESS;
}
